| The Gaudi Framework v29r1 (5cd95fa2)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Private Attributes | List of all members
StoreExplorerAlg Class Reference

Small algorith, which traverses the data store and prints generic information about all leaves, which can be loaded/accessed. More...

Inheritance diagram for StoreExplorerAlg:
[legend]
Collaboration diagram for StoreExplorerAlg:
[legend]

## Public Member Functions
| ~StoreExplorerAlg () override=default
| Standard Destructor. More...
template<class T >
std::string | access (T *p)
void | printObj (IRegistry *pReg, std::vector< bool > &flg)
| Print datastore leaf. More...
void | explore (IRegistry *pObj, std::vector< bool > &flg)
StatusCode | initialize () override
| Initialize. More...
StatusCode | finalize () override
| Finalize. More...
StatusCode | execute () override
| Execute procedure. More...
Public Member Functions inherited from Algorithm
| Algorithm (const std::string &name, ISvcLocator *svcloc, const std::string &version=PACKAGE_VERSION)
| Constructor. More...
StatusCode | sysStart () override
| Reinitialization method invoked by the framework. More...
StatusCode | sysInitialize () override
| Initialization method invoked by the framework. More...
StatusCode | sysReinitialize () override
| Reinitialization method invoked by the framework. More...
StatusCode | sysRestart () override
| Restart method invoked by the framework. More...
StatusCode | sysExecute (const EventContext &ctx) override
| The actions to be performed by the algorithm on an event. More...
StatusCode | sysStop () override
| System stop. More...
StatusCode | sysFinalize () override
| System finalization. More...
StatusCode | sysBeginRun () override
| beginRun method invoked by the framework. More...
StatusCode | sysEndRun () override
| endRun method invoked by the framework. More...
const std::string & | name () const override
| The identifying name of the algorithm object. More...
const Gaudi::StringKey & | nameKey () const override
const std::string & | type () const override
| The type of the algorithm object. More...
void | setType (const std::string &type) override
const std::string & | version () const override
unsigned int | index () const override
StatusCode | configure () override
| Dummy implementation of IStateful::configure() method. More...
StatusCode | terminate () override
| Dummy implementation of IStateful::terminate() method. More...
StatusCode | initialize () override
| the default (empty) implementation of IStateful::initialize() method More...
StatusCode | start () override
| the default (empty) implementation of IStateful::start() method More...
StatusCode | stop () override
| the default (empty) implementation of IStateful::stop() method More...
StatusCode | finalize () override
| the default (empty) implementation of IStateful::finalize() method More...
StatusCode | reinitialize () override
| the default (empty) implementation of IStateful::reinitialize() method More...
StatusCode | restart () override
| the default (empty) implementation of IStateful::restart() method More...
Gaudi::StateMachine::State | FSMState () const override
| returns the current state of the algorithm More...
Gaudi::StateMachine::State | targetFSMState () const override
| returns the state the algorithm will be in after the ongoing transition More...
bool | isExecuted () const override
| Has this algorithm been executed since the last reset? More...
void | setExecuted (bool state) const override
| Set the executed flag to the specified state. More...
void | resetExecuted () override
| Reset the executed state of the Algorithm for the duration of the current event. More...
StatusCode | beginRun () override
| Algorithm begin run. More...
StatusCode | endRun () override
| Algorithm end run. This method is called at the end of the event loop. More...
bool | isEnabled () const override
| Is this algorithm enabled or disabled? More...
bool | isSequence () const override
| Are we a Sequence? More...
bool | filterPassed () const override
| Did this algorithm pass or fail its filter criterion for the last event? More...
void | setFilterPassed (bool state) const override
| Set the filter passed flag to the specified state. More...
unsigned int | errorCount () const
| Get the number of failures of the algorithm. More...
template<class T >
StatusCode | service (const std::string &name, T *&psvc, bool createIf=true) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &svcType, const std::string &svcName, T *&psvc) const
| Access a service by name and type, creating it if it doesn't already exist. More...
SmartIF< IService > | service (const std::string &name, const bool createIf=true, const bool quiet=false) const
| Return a pointer to the service identified by name (or "type/name") More...
template<class T >
SmartIF< T > | service (const std::string &name, bool createIf=true, bool quiet=false) const
SmartIF< IAuditorSvc > & | auditorSvc () const
| The standard auditor service.May not be invoked before sysInitialize() has been invoked. More...
SmartIF< IChronoStatSvc > & | chronoSvc () const
| The standard Chrono & Stat service, Return a pointer to the service if present. More...
SmartIF< IChronoStatSvc > & | chronoStatService () const
SmartIF< IDataProviderSvc > & | detSvc () const
| The standard detector data service. More...
SmartIF< IDataProviderSvc > & | detDataService () const
SmartIF< IConversionSvc > & | detCnvSvc () const
| The standard detector data persistency conversion service. More...
SmartIF< IConversionSvc > & | detDataCnvService () const
SmartIF< IDataProviderSvc > & | eventSvc () const
| The standard event data service. More...
SmartIF< IDataProviderSvc > & | evtSvc () const
| shortcut for method eventSvc More...
SmartIF< IDataProviderSvc > & | eventDataService () const
SmartIF< IConversionSvc > & | eventCnvSvc () const
| The standard event data persistency conversion service. More...
SmartIF< IConversionSvc > & | eventDataCnvService () const
SmartIF< IHistogramSvc > & | histoSvc () const
| The standard histogram service. More...
SmartIF< IHistogramSvc > & | histogramDataService () const
SmartIF< INTupleSvc > & | ntupleSvc () const
| The standard N tuple service. More...
SmartIF< INTupleSvc > & | ntupleService () const
SmartIF< IRndmGenSvc > & | randSvc () const
| The standard RandomGen service, Return a pointer to the service if present. More...
SmartIF< IToolSvc > & | toolSvc () const
| The standard ToolSvc service, Return a pointer to the service if present. More...
SmartIF< IExceptionSvc > & | exceptionSvc () const
| Get the exception Service. More...
SmartIF< IAlgContextSvc > & | contextSvc () const
| get Algorithm Context Service More...
SmartIF< ITimelineSvc > & | timelineSvc () const
SmartIF< ISvcLocator > & | serviceLocator () const override
| The standard service locator. More...
SmartIF< ISvcLocator > & | svcLoc () const
| shortcut for method serviceLocator More...
SmartIF< IHiveWhiteBoard > & | whiteboard () const
SmartIF< IAlgExecStateSvc > & | algExecStateSvc () const
bool | registerContext () const
| register for Algorithm Context Service? More...
StatusCode | createSubAlgorithm (const std::string &type, const std::string &name, Algorithm *&pSubAlg)
| Create a sub algorithm. More...
const std::vector< Algorithm * > * | subAlgorithms () const
| List of sub-algorithms. Returns a pointer to a vector of (sub) Algorithms. More...
std::vector< Algorithm * > * | subAlgorithms ()
| List of sub-algorithms. Returns a pointer to a vector of (sub) Algorithms. More...
StatusCode | setProperties ()
| Set the algorithm's properties. More...
template<class T >
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, ToolHandle< T > &hndl, const std::string &doc="none")
template<class T >
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, ToolHandleArray< T > &hndlArr, const std::string &doc="none")
SmartIF< IMonitorSvc > & | monitorSvc () const
| Access the monitor service. More...
template<class T >
void | declareInfo (const std::string &name, const T &var, const std::string &desc) const
| Declare monitoring information. More...
void | declareInfo (const std::string &name, const std::string &format, const void *var, int size, const std::string &desc) const
| Declare monitoring information (special case) More...
const EventContext & | getContext () const override
| get the context More...
virtual void | acceptDHVisitor (IDataHandleVisitor *) const override
void | commitHandles () override
void | registerTool (IAlgTool *tool) const
void | deregisterTool (IAlgTool *tool) const
template<class T >
StatusCode | declareTool (ToolHandle< T > &handle, std::string toolTypeAndName, bool createIf=true)
template<class T >
void | addToolsArray (ToolHandleArray< T > &hndlArr)
const std::vector< IAlgTool * > & | tools () const
bool | isIOBound () const
void | setIOBound (bool value)
unsigned int | cardinality () const override
| Return the cardinality. More...
const std::vector< std::string > & | neededResources () const override
std::ostream & | toControlFlowExpression (std::ostream &os) const override
| Produce string represention of the control flow expression. More...
Public Member Functions inherited from DataHandleHolderBase< PropertyHolder< CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > > > >
std::vector< Gaudi::DataHandle * > | inputHandles () const override
std::vector< Gaudi::DataHandle * > | outputHandles () const override
virtual const DataObjIDColl & | extraInputDeps () const override
virtual const DataObjIDColl & | extraOutputDeps () const override
void | declare (Gaudi::DataHandle &handle) override
void | renounce (Gaudi::DataHandle &handle) override
const DataObjIDColl & | inputDataObjs () const override
const DataObjIDColl & | outputDataObjs () const override
void | addDependency (const DataObjID &id, const Gaudi::DataHandle::Mode &mode) override
Public Member Functions inherited from extends< PropertyHolder< CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > > >, IDataHandleHolder >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
| ~extends () override=default
| Virtual destructor. More...
Public Member Functions inherited from PropertyHolder< CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > > >
| PropertyHolder ()=default
| ~PropertyHolder () override=default
Gaudi::Details::PropertyBase & | declareProperty (Gaudi::Details::PropertyBase &prop)
| Declare a property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none")
| Helper to wrap a regular data member and use it as a regular property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none") const
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, Gaudi::Property< TYPE, VERIFIER, HANDLERS > &prop, const std::string &doc="none")
| Declare a PropertyBase instance setting name and documentation. More...
Gaudi::Details::PropertyBase * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="")
| Declare a remote property. More...
StatusCode | setProperty (const Gaudi::Details::PropertyBase &p) override
| set the property form another property More...
StatusCode | setProperty (const std::string &s) override
| set the property from the formatted string More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| set the property from name and the value More...
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
StatusCode | getProperty (Gaudi::Details::PropertyBase *p) const override
| get the property More...
const Gaudi::Details::PropertyBase & | getProperty (const std::string &name) const override
| get the property by name More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| convert the property to the string More...
const std::vector< Gaudi::Details::PropertyBase * > & | getProperties () const override
| get all properties More...
bool | hasProperty (const std::string &name) const override
| Return true if we have a property with the given name. More...
| PropertyHolder (const PropertyHolder &)=delete
PropertyHolder & | operator= (const PropertyHolder &)=delete
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, GaudiHandleBase &ref, const std::string &doc="none")
| Specializations for various GaudiHandles. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, GaudiHandleArrayBase &ref, const std::string &doc="none")
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, DataObjectHandleBase &ref, const std::string &doc="none")
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
const SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...
MSG::Level | msgLevel () const
| get the cached level (originally extracted from the embedded MsgStream) More...
MSG::Level | outputLevel () const __attribute__((deprecated))
| Backward compatibility function for getting the output level. More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...
Public Member Functions inherited from extend_interfaces< Interfaces... >
| ~extend_interfaces () override=default
| Virtual destructor. More...

## Private Attributes
Gaudi::Property< bool > | m_load {this, "Load", false, "load non existing items"}
Gaudi::Property< long > | m_print {this, "PrintEvt", 1, "limit printout to first N events"}
Gaudi::Property< long > | m_printMissing {this, "PrintMissing", 0, "indicate if missing entities should be printed"}
Gaudi::Property< double > | m_frequency {this, "PrintFreq", 0.0, "printout frequency"}
Gaudi::Property< bool > | m_exploreRelations {this, "ExploreRelations", false, "if relations should be followed"}
Gaudi::Property< std::string > | m_dataSvcName {this, "DataSvc", "EventDataSvc", "name of the data provider service"}
Gaudi::Property< bool > | m_testAccess
Gaudi::Property< bool > | m_accessForeign {this, "AccessForeign", false, "indicate if foreign files should be opened"}
long | m_total = 0
| Internal counter to trigger printouts. More...
long | m_frqPrint = 0
| Internal counter to adjust printout frequency. More...
SmartIF< IDataProviderSvc > | m_dataSvc
| Reference to data provider service. More...
std::string | m_rootName
| Name of the root leaf (obtained at initialize) More...

## Additional Inherited Members
Public Types inherited from Algorithm
typedef Gaudi::PluginService::Factory< IAlgorithm *, const std::string &, ISvcLocator * > | Factory
Public Types inherited from extends< PropertyHolder< CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > > >, IDataHandleHolder >
using | base_class = extends
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces... >
| Typedef to the base of this class. More...
Public Types inherited from PropertyHolder< CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > > >
using | PropertyHolderImpl = PropertyHolder< CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > > >
| Typedef used to refer to this class from derived classes, as in. More...
Public Types inherited from CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > >
using | base_class = CommonMessaging
Public Types inherited from extend_interfaces< Interfaces... >
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids... >::type
| take union of the ext_iids of all Interfaces... More...
Public Attributes inherited from Algorithm
friend | AlgorithmManager
Protected Member Functions inherited from Algorithm
std::vector< IAlgTool * > & | tools ()
bool | isInitialized () const override
| Has the Algorithm already been initialized? More...
bool | isFinalized () const override
| Has the Algorithm already been finalized? More...
void | setIndex (const unsigned int &idx) override
| set instantiation index of Alg More...
Protected Member Functions inherited from DataHandleHolderBase< PropertyHolder< CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > > > >
void | initDataHandleHolder ()
| initializes all handles - called by the sysInitialize method of any descendant of this More...
Protected Member Functions inherited from PropertyHolder< CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > > >
Gaudi::Details::PropertyBase * | property (const std::string &name) const
Protected Member Functions inherited from CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > >
MSG::Level | setUpMessaging ()
| Set up local caches. More...
MSG::Level | resetMessaging ()
| Reinitialize internal states. More...
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...
Protected Attributes inherited from Algorithm
std::unique_ptr< IDataHandleVisitor > | m_updateDataHandles
| Hook for for derived classes to provide a custom visitor for data handles. More...
Protected Attributes inherited from DataHandleHolderBase< PropertyHolder< CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > > > >
DataObjIDColl | m_inputDataObjs
DataObjIDColl | m_outputDataObjs

## Detailed Description

Small algorith, which traverses the data store and prints generic information about all leaves, which can be loaded/accessed.

Author
  : M.Frank

Version
  : 1.0

Definition at line 32 of file StoreExplorerAlg.cpp.

## Constructor & Destructor Documentation

StoreExplorerAlg::~StoreExplorerAlg | ( |  | ) |
| override default

Standard Destructor.

## Member Function Documentation

template<class T >

std::string StoreExplorerAlg::access | ( | T * | p | ) |
| inline

Definition at line 62 of file StoreExplorerAlg.cpp.

63 {
64 if ( !p ) return "Access FAILED.";
65 std::string result = std::accumulate(
66 std::begin( *p ), std::end( *p ), std::string{}, [&]( std::string s, typename T::const_reference i ) {
67 return s + std::to_string( p->index( i ) ) + ":" + std::to_string( i->clID() ) + ",";
68 } );
69 return result.substr( 0, result.length() - 2 );
70 }
std::to_string
T to_string(T...args)
std::end
T end(T...args)
std::string
STL class.
std::string::length
T length(T...args)
std::begin
T begin(T...args)
gaudirun.s
string s
Definition: gaudirun.py:253
std::string::substr
T substr(T...args)
std::accumulate
T accumulate(T...args)

StatusCode StoreExplorerAlg::execute | ( |  | ) |
| inline override

Execute procedure.

Definition at line 204 of file StoreExplorerAlg.cpp.

205 {
206 SmartDataPtr<DataObject> root( m_dataSvc.get(), m_rootName );
207 if ( ( ( m_print > m_total++ ) || ( m_frequency * m_total > m_frqPrint ) ) && root ) {
208 if ( m_frequency * m_total > m_frqPrint ) m_frqPrint++;
209 std::string store_name = "Unknown";
210 IRegistry* pReg = root->registry();
211 if ( pReg ) {
212 auto isvc = SmartIF<IService>{pReg->dataSvc()};
213 if ( isvc ) store_name = isvc->name();
214 }
215 info() << "========= " << m_rootName << "[" << std::showbase << std::hex << (unsigned long)root.ptr() << std::dec
216 << "@" << store_name << "]:" << endmsg;
217 std::vector<bool> flg( 1, true );
218 explore( root->registry(), flg );
219 return StatusCode::SUCCESS;
220 } else if ( root ) {
221 return StatusCode::SUCCESS;
222 }
223 error() << "Cannot retrieve \"/Event\"!" << endmsg;
224 return StatusCode::FAILURE;
225 }
StatusCode::SUCCESS
Definition: StatusCode.h:31
SmartIF< IService >
StatusCode::FAILURE
Definition: StatusCode.h:31
CommonMessagingBase::info
MsgStream & info() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:112
StoreExplorerAlg::m_dataSvc
SmartIF< IDataProviderSvc > m_dataSvc
Reference to data provider service.
Definition: StoreExplorerAlg.cpp:50
std::showbase
T showbase(T...args)
StoreExplorerAlg::m_total
long m_total
Internal counter to trigger printouts.
Definition: StoreExplorerAlg.cpp:46
StoreExplorerAlg::m_frequency
Gaudi::Property< double > m_frequency
Definition: StoreExplorerAlg.cpp:38
std::string
STL class.
SmartIF::get
TYPE * get() const
Get interface pointer.
Definition: SmartIF.h:82
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:106
StoreExplorerAlg::m_rootName
std::string m_rootName
Name of the root leaf (obtained at initialize)
Definition: StoreExplorerAlg.cpp:52
IRegistry::dataSvc
virtual IDataProviderSvc * dataSvc() const =0
Retrieve pointer to Transient Store.
IRegistry
The IRegistry represents the entry door to the environment any data object residing in a transient da...
Definition: IRegistry.h:22
StoreExplorerAlg::m_print
Gaudi::Property< long > m_print
Definition: StoreExplorerAlg.cpp:36
StoreExplorerAlg::explore
void explore(IRegistry *pObj, std::vector< bool > &flg)
Definition: StoreExplorerAlg.cpp:136
std::vector< bool >
SmartDataPtr
A small class used to access easily (and efficiently) data items residing in data stores...
Definition: SmartDataPtr.h:47
std::hex
T hex(T...args)
gaudiComponentHelp.root
root
Definition: gaudiComponentHelp.py:18
StoreExplorerAlg::m_frqPrint
long m_frqPrint
Internal counter to adjust printout frequency.
Definition: StoreExplorerAlg.cpp:48
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209

void StoreExplorerAlg::explore | ( | IRegistry * | pObj,
|  | std::vector< bool > & | flg
| ) |  |
| inline

Definition at line 136 of file StoreExplorerAlg.cpp.

137 {
138 printObj( pObj, flg );
139 if ( pObj ) {
140 auto mgr = eventSvc().as<IDataManagerSvc>();
141 if ( mgr ) {
142 std::vector<IRegistry*> leaves;
143 StatusCode sc = mgr->objectLeaves( pObj, leaves );
144 const std::string* par0 = nullptr;
145 if ( pObj->address() ) par0 = pObj->address()->par();
146 if ( sc.isSuccess() ) {
147 for ( auto i = leaves.begin(); i != leaves.end(); i++ ) {
148 const std::string& id = ( *i )->identifier();
149 DataObject* p = nullptr;
150 if ( !m_accessForeign && ( *i )->address() ) {
151 if ( par0 ) {
152 const std::string* par1 = ( *i )->address()->par();
153 if ( par1 && par0[0] != par1[0] ) continue;
154 }
155 }
156 if ( m_load ) {
157 sc = eventSvc()->retrieveObject( id, p );
158 } else {
159 sc = eventSvc()->findObject( id, p );
160 }
161 if ( sc.isSuccess() ) {
162 if ( id != "/Event/Rec/Relations" || m_exploreRelations ) {
163 flg.push_back( i + 1 == leaves.end() );
164 explore( *i, flg );
165 flg.pop_back();
166 }
167 } else {
168 flg.push_back( i + 1 == leaves.end() );
169 printObj( *i, flg );
170 flg.pop_back();
171 }
172 }
173 }
174 }
175 }
176 }
StoreExplorerAlg::m_exploreRelations
Gaudi::Property< bool > m_exploreRelations
Definition: StoreExplorerAlg.cpp:39
Algorithm::eventSvc
SmartIF< IDataProviderSvc > & eventSvc() const
The standard event data service.
Definition: Algorithm.cpp:798
StatusCode::isSuccess
bool isSuccess() const
Test for a status code of SUCCESS.
Definition: StatusCode.h:75
StoreExplorerAlg::m_accessForeign
Gaudi::Property< bool > m_accessForeign
Definition: StoreExplorerAlg.cpp:43
std::vector::end
T end(T...args)
IOpaqueAddress::par
virtual const std::string * par() const =0
Retrieve String parameters.
std::string
STL class.
std::vector::push_back
T push_back(T...args)
SmartIF::as
SmartIF< IFace > as() const
return a new SmartIF instance to another interface
Definition: SmartIF.h:115
IDataProviderSvc::findObject
virtual StatusCode findObject(IRegistry *pDirectory, const std::string &path, DataObject *&pObject)=0
Find object identified by its directory entry.
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:28
std::vector::pop_back
T pop_back(T...args)
StoreExplorerAlg::printObj
void printObj(IRegistry *pReg, std::vector< bool > &flg)
Print datastore leaf.
Definition: StoreExplorerAlg.cpp:73
StoreExplorerAlg::explore
void explore(IRegistry *pObj, std::vector< bool > &flg)
Definition: StoreExplorerAlg.cpp:136
std::vector< IRegistry * >
IDataManagerSvc
Definition: IDataManagerSvc.h:45
std::vector::begin
T begin(T...args)
IRegistry::address
virtual IOpaqueAddress * address() const =0
Retrieve opaque storage address.
DataObject
A DataObject is the base class of any identifiable object on any data store.
Definition: DataObject.h:29
StoreExplorerAlg::m_load
Gaudi::Property< bool > m_load
Definition: StoreExplorerAlg.cpp:35
IDataProviderSvc::retrieveObject
virtual StatusCode retrieveObject(IRegistry *pDirectory, const std::string &path, DataObject *&pObject)=0
Retrieve object identified by its directory entry.

StatusCode StoreExplorerAlg::finalize | ( |  | ) |
| inline override

Finalize.

Definition at line 197 of file StoreExplorerAlg.cpp.

198 {
199 m_dataSvc.reset();
200 return StatusCode::SUCCESS;
201 }
StatusCode::SUCCESS
Definition: StatusCode.h:31
StoreExplorerAlg::m_dataSvc
SmartIF< IDataProviderSvc > m_dataSvc
Reference to data provider service.
Definition: StoreExplorerAlg.cpp:50
SmartIF::reset
void reset(TYPE *ptr=nullptr)
Set the internal pointer to the passed one disposing of the old one.
Definition: SmartIF.h:92

StatusCode StoreExplorerAlg::initialize | ( |  | ) |
| inline override

Initialize.

Definition at line 179 of file StoreExplorerAlg.cpp.

180 {
181 m_rootName.clear();
182 m_dataSvc = service( m_dataSvcName, true );
183 if ( !m_dataSvc ) {
184 error() << "Failed to access service \"" << m_dataSvcName << "\"." << endmsg;
185 return StatusCode::FAILURE;
186 }
187 auto mgr = m_dataSvc.as<IDataManagerSvc>();
188 if ( !mgr ) {
189 error() << "Failed to retrieve IDataManagerSvc interface." << endmsg;
190 return StatusCode::FAILURE;
191 }
192 m_rootName = mgr->rootName();
193 return StatusCode::SUCCESS;
194 }
StatusCode::SUCCESS
Definition: StatusCode.h:31
StatusCode::FAILURE
Definition: StatusCode.h:31
StoreExplorerAlg::m_dataSvc
SmartIF< IDataProviderSvc > m_dataSvc
Reference to data provider service.
Definition: StoreExplorerAlg.cpp:50
StoreExplorerAlg::m_dataSvcName
Gaudi::Property< std::string > m_dataSvcName
Definition: StoreExplorerAlg.cpp:40
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:106
SmartIF::as
SmartIF< IFace > as() const
return a new SmartIF instance to another interface
Definition: SmartIF.h:115
StoreExplorerAlg::m_rootName
std::string m_rootName
Name of the root leaf (obtained at initialize)
Definition: StoreExplorerAlg.cpp:52
std::string::clear
T clear(T...args)
IDataManagerSvc
Definition: IDataManagerSvc.h:45
Algorithm::service
StatusCode service(const std::string &name, T *&psvc, bool createIf=true) const
Access a service by name, creating it if it doesn&#39;t already exist.
Definition: Algorithm.h:233
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209

void StoreExplorerAlg::printObj | ( | IRegistry * | pReg,
|  | std::vector< bool > & | flg
| ) |  |
| inline

Print datastore leaf.

Definition at line 73 of file StoreExplorerAlg.cpp.

74 {
75 auto& log = info();
76 for ( size_t j = 1; j < flg.size(); j++ ) {
77 if ( !flg[j - 1] && flg[j] )
78 log << "| ";
79 else if ( flg[j] )
80 log << " ";
81 else
82 log << "| ";
83 }
84 log << "+--> " << pReg->name();
85 if ( pReg->address() ) {
86 log << " [Address: CLID=" << std::showbase << std::hex << pReg->address()->clID()
87 << " Type=" << (void*)pReg->address()->svcType() << "]";
88 } else {
89 log << " [No Address]";
90 }
91 DataObject* p = pReg->object();
92 if ( p ) {
93 try {
94 std::string typ = System::typeinfoName( typeid( *p ) );
95 if ( m_testAccess ) p->clID();
96 log << " " << typ.substr( 0, 32 );
97 } catch ( ... ) {
98 log << "Access test FAILED";
99 }
100 } else {
101 log << " (Unloaded) ";
102 }
103 ObjectContainerBase* base = dynamic_cast<ObjectContainerBase*>( p );
104 if ( base ) {
105 try {
106 int numObj = base->numberOfObjects();
107 const CLID id = p->clID();
108 log << " [" << numObj << "]";
109 if ( m_testAccess ) {
110 CLID idd = id >> 16;
111 switch ( idd ) {
112 case CLID_ObjectList >> 16: /* ObjectList */
113 access( (ObjectList<ContainedObject>*)base );
114 break;
115 case CLID_ObjectVector >> 16: /* ObjectVector */
116 access( (ObjectVector<ContainedObject>*)base );
117 break;
118 case ( CLID_ObjectVector + 0x00030000 ) >> 16: /* Keyed Map */
119 access( (KeyedContainer<KeyedObject<int>, Containers::Map>*)base );
120 break;
121 case ( CLID_ObjectVector + 0x00040000 ) >> 16: /* Keyed Hashmap */
122 access( (KeyedContainer<KeyedObject<int>, Containers::HashMap>*)base );
123 break;
124 case ( CLID_ObjectVector + 0x00050000 ) >> 16: /* Keyed array */
125 access( (KeyedContainer<KeyedObject<int>, Containers::Array>*)base );
126 break;
127 }
128 }
129 } catch ( ... ) {
130 log << "Access test FAILED";
131 }
132 }
133 log << endmsg;
134 }
IOpaqueAddress::clID
virtual const CLID & clID() const =0
Retrieve class information from link.
KeyedObject
Definition of the templated KeyedObject class.
Definition: KeyedObject.h:30
CommonMessagingBase::info
MsgStream & info() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:112
System::typeinfoName
GAUDI_API const std::string typeinfoName(const std::type_info &)
Get platform independent information about the class type.
Definition: System.cpp:329
ObjectVector
ObjectVector is one of the basic Gaudi container classes capable of being registered in Data Stores...
Definition: ContainedObject.h:12
KeyedContainer
template class KeyedContainer, KeyedContainer.h
Definition: KeyedContainer.h:65
IRegistry::name
virtual const name_type & name() const =0
Name of the directory (or key)
std::showbase
T showbase(T...args)
ObjectList
ObjectList is one of the basic Gaudi container classes capable of being registered in Data Stores...
Definition: ContainedObject.h:14
std::string
STL class.
StoreExplorerAlg::m_testAccess
Gaudi::Property< bool > m_testAccess
Definition: StoreExplorerAlg.cpp:41
DataObject::clID
virtual const CLID & clID() const
Retrieve reference to class definition structure.
Definition: DataObject.cpp:62
IOpaqueAddress::svcType
virtual long svcType() const =0
Retrieve service type.
CLID
unsigned int CLID
Class ID definition.
Definition: ClassID.h:8
IRegistry::object
virtual DataObject * object() const =0
Retrieve object behind the link.
std::vector::size
T size(T...args)
Containers::KeyedObjectManager
KeyedObjectManager Class to manage keyed objects.
Definition: KeyedObjectManager.h:46
std::hex
T hex(T...args)
std::string::substr
T substr(T...args)
ObjectContainerBase
ObjectContainerBase is the base class for Gaudi container classes.
Definition: ObjectContainerBase.h:19
ObjectContainerBase::numberOfObjects
virtual size_type numberOfObjects() const =0
Number of objects in the container.
IRegistry::address
virtual IOpaqueAddress * address() const =0
Retrieve opaque storage address.
DataObject
A DataObject is the base class of any identifiable object on any data store.
Definition: DataObject.h:29
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209
StoreExplorerAlg::access
std::string access(T *p)
Definition: StoreExplorerAlg.cpp:62
Gaudi.Configuration.log
log
Definition: Configuration.py:13

## Member Data Documentation

Gaudi::Property<bool> StoreExplorerAlg::m_accessForeign {this, "AccessForeign", false, "indicate if foreign files should be opened"}
| private

Definition at line 43 of file StoreExplorerAlg.cpp.

SmartIF<IDataProviderSvc> StoreExplorerAlg::m_dataSvc
| private

Reference to data provider service.

Definition at line 50 of file StoreExplorerAlg.cpp.

Gaudi::Property<std::string> StoreExplorerAlg::m_dataSvcName {this, "DataSvc", "EventDataSvc", "name of the data provider service"}
| private

Definition at line 40 of file StoreExplorerAlg.cpp.

Gaudi::Property<bool> StoreExplorerAlg::m_exploreRelations {this, "ExploreRelations", false, "if relations should be followed"}
| private

Definition at line 39 of file StoreExplorerAlg.cpp.

Gaudi::Property<double> StoreExplorerAlg::m_frequency {this, "PrintFreq", 0.0, "printout frequency"}
| private

Definition at line 38 of file StoreExplorerAlg.cpp.

long StoreExplorerAlg::m_frqPrint = 0
| private

Internal counter to adjust printout frequency.

Definition at line 48 of file StoreExplorerAlg.cpp.

Gaudi::Property<bool> StoreExplorerAlg::m_load {this, "Load", false, "load non existing items"}
| private

Definition at line 35 of file StoreExplorerAlg.cpp.

Gaudi::Property<long> StoreExplorerAlg::m_print {this, "PrintEvt", 1, "limit printout to first N events"}
| private

Definition at line 36 of file StoreExplorerAlg.cpp.

Gaudi::Property<long> StoreExplorerAlg::m_printMissing {this, "PrintMissing", 0, "indicate if missing entities should be printed"}
| private

Definition at line 37 of file StoreExplorerAlg.cpp.

std::string StoreExplorerAlg::m_rootName
| private

Name of the root leaf (obtained at initialize)

Definition at line 52 of file StoreExplorerAlg.cpp.

Gaudi::Property<bool> StoreExplorerAlg::m_testAccess
| private

Initial value:
{this, "TestAccess", false,
"test access to objects (DataObject and ContainedObject)"}

Definition at line 41 of file StoreExplorerAlg.cpp.

long StoreExplorerAlg::m_total = 0
| private

Internal counter to trigger printouts.

Definition at line 46 of file StoreExplorerAlg.cpp.

The documentation for this class was generated from the following file:

- GaudiCommonSvc/src/DataSvc/StoreExplorerAlg.cpp